<?php
/*
Plugin Name: WP Smart Contracts
Plugin URI: https://www.wpsmartcontracts.com/
Description: Easily create powerful Smart Contracts in a dozen of blockchain networks.
Version: 1.3.5
Author: WPSmartContracts.com
Text Domain: wp-smart-contracts
Domain Path: /languages
License: GPLv2 or later
*/

if( ! defined( 'ABSPATH' ) ) die;

/**
 * Load generic helpers
 */
require_once("classes/wpsc-helpers.php");

/**
 * Template system, in JS and PHP
 */
require_once("classes/wpsc-mustache.php");

/**
 * Dashboard
 */
require_once("classes/wpsc-dashboard.php");

/**
 * Create Custom Post Types
 */
require_once("classes/wpsc-cpt.php");

/**
 * Load css and js
 */
require_once("classes/wpsc-assets.php");

/**
 * Load shortcodes
 */
require_once("classes/wpsc-shortcodes.php");

/**
 * Load Queries
 */
require_once("classes/wpsc-queries.php");

/**
 * Load wp-admin settings
 */
require_once("classes/wpsc-settings.php");

/**
 * Load Block Explorer Options
 */
require_once("classes/wpsc-endpoints.php");

/**
 * Load Clean Template
 */
require_once("classes/wpsc-page-templater.php");

/**
 * Create QR Scanner page on plugin activate
 */
add_action('init', function() {
    WPSC_helpers::createPluginPages();
});

/**
 * IPFS
 */
require_once(__DIR__ . "/classes/wpsc-rest-client.php");
require_once(__DIR__ . "/classes/wpsc-media-ipfs.php");

/**
 * Internal use only, load deployer
 */
if (file_exists(__DIR__ . "/classes/wpsc-deployer.php")) {
    require_once(__DIR__ . "/classes/wpsc-deployer.php");
}

/**
 * Bulk Mint
 */
require_once("classes/wpsc-bulk-mint.php");


add_filter( 'upload_mimes', function ($mimes) {
	$mimes['glb'] = 'model/gltf-binary';
	$mimes['gltf'] = 'model/gltf-binary';
    return $mimes;
});

function wpsc_add_exception($data, $file, $filename,$mimes,$real_mime=null){
	$f_sp = explode(".", $filename);
	$f_exp_count  = count ($f_sp);

	if($f_exp_count <= 1) {
		return $data;
	} else {
		$f_name = $f_sp[0];
		$ext  = $f_sp[$f_exp_count - 1];
	}

	if($ext == 'glb') {
		$type = 'model/gltf-binary';
		$proper_filename = '';
		return compact('ext', 'type', 'proper_filename');
	} 
    if($ext == 'gltf') {
		$type = 'model/gltf-binary';
		$proper_filename = '';
		return compact('ext', 'type', 'proper_filename');
	} else {
		return $data;
	}
}

global $wp_version;
if ( version_compare( $wp_version, '5.1') >= 0) {
	add_filter( 'wp_check_filetype_and_ext', 'wpsc_add_exception',10,5);
} else {
	add_filter( 'wp_check_filetype_and_ext', 'wpsc_add_exception',10,4);
}